"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
var prefixCls = 'r-titlebar';
var Titlebar = /*#__PURE__*/(0, _react.memo)(function (_ref) {
  var theme = _ref.theme,
    l = _ref.l,
    title = _ref.title,
    r = _ref.r,
    children = _ref.children,
    showBackto = _ref.showBackto,
    backArrowStyle = _ref.backArrowStyle,
    onBack = _ref.onBack,
    className = _ref.className;
  var wrapCls = [prefixCls, "".concat(prefixCls, "-theme-").concat(theme), className].filter(Boolean).join(' ');
  console.log('Titlebar mounted or updated');
  return /*#__PURE__*/_react.default.createElement("div", {
    className: wrapCls
  }, showBackto && /*#__PURE__*/_react.default.createElement("div", {
    className: "l-operate",
    onClick: function onClick(e) {
      return onBack && onBack(e);
    }
  }, l ? l : /*#__PURE__*/_react.default.createElement("div", {
    className: "back"
  }, /*#__PURE__*/_react.default.createElement("svg", {
    width: "10px",
    height: "21px",
    style: backArrowStyle,
    viewBox: "0 0 10 21",
    version: "1.1"
  }, /*#__PURE__*/_react.default.createElement("g", {
    stroke: "none",
    strokeWidth: "1",
    fill: "none",
    fillRule: "evenodd",
    strokeLinecap: "round"
  }, /*#__PURE__*/_react.default.createElement("g", {
    transform: "translate(-16.000000, -33.000000)",
    stroke: "currentColor"
  }, /*#__PURE__*/_react.default.createElement("polyline", {
    id: "Path-2",
    points: "25.758131 34 16 43.3837058 26 53"
  })))))), /*#__PURE__*/_react.default.createElement("div", {
    className: "c-operate"
  }, title || children), r && /*#__PURE__*/_react.default.createElement("div", {
    className: "r-operate"
  }, r));
});
Titlebar.defaultProps = {
  theme: 'a',
  showBackto: true
};
Titlebar.propTypes = {
  theme: _propTypes.default.string,
  showBackto: _propTypes.default.bool,
  backArrowStyle: _propTypes.default.object
};
Titlebar.displayName = 'Titlebar';
var _default = exports.default = Titlebar;