function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
export function setDefaultProps(component) {
  var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var defaultProps = {};
  var propTypes = {};
  for (var key in props) {
    defaultProps[key] = props[key].default;
    propTypes[key] = props[key].type;
  }
  component['defaultProps'] = defaultProps;
  component['propTypes'] = propTypes;
}
export function classNames() {
  var classes = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var arr = [];
  classes.forEach(function (item) {
    if (_typeof(item) === 'object') {
      for (var key in item) {
        if (item[key] === true) {
          arr.push(key);
        }
      }
    } else {
      arr.push(item);
    }
  });
  return arr.filter(Boolean).join(' ');
}