import createToast, { setGlobalConfig } from './createToast';
var negetiveToast = function negetiveToast(options) {
  if (typeof options === 'string') {
    options = {
      content: options
    };
  }
  options.type = 'negetive';
  createToast(options);
};
var positiveToast = function positiveToast(options) {
  if (typeof options === 'string') {
    options = {
      content: options
    };
  }
  options.type = 'positive';
  createToast(options);
};
var Toast = {
  create: createToast,
  config: setGlobalConfig,
  negetive: negetiveToast,
  positive: positiveToast
};
export default Toast;