"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _excluded = ["forwardedRef"];
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function preventScroll(WrappedComponent) {
  var PreventScroll = /*#__PURE__*/function (_Component) {
    _inherits(PreventScroll, _Component);
    var _super = _createSuper(PreventScroll);
    function PreventScroll(props) {
      var _this;
      _classCallCheck(this, PreventScroll);
      _this = _super.call(this, props);
      _this.init = function (_ref) {
        var el = _ref.el;
        _this.el = el;
        _this.bindEvent();
      };
      _this.state = {};
      return _this;
    }
    _createClass(PreventScroll, [{
      key: "componentDidMount",
      value: function componentDidMount() {}
    }, {
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        if (this.el) {
          this.el.removeEventListener('touchstart', this.el.__handleTouchstart__, false);
          this.el.removeEventListener('touchmove', this.el.__handleTouchmove__, false);
          delete this.el.__handleTouchstart__;
          delete this.el.__handleTouchmove__;
        }
      }
    }, {
      key: "bindEvent",
      value: function bindEvent() {
        var currentScrollArea = null;
        var mouseInfo = {
          startX: 0,
          startY: 0,
          direction: ''
        };
        var searchScrollArea = function searchScrollArea(el) {
          var scrollArea = null;
          while (el) {
            if (el.className && el.className.indexOf && el.className.indexOf('scroll-area') > -1) {
              scrollArea = el;
              break;
            }
            el = el.parentNode;
          }
          return scrollArea;
        };
        var handleTouchstart = function handleTouchstart(e) {
          currentScrollArea = searchScrollArea(e.target);
          mouseInfo.startX = e.targetTouches[0].clientX;
          mouseInfo.startY = e.targetTouches[0].clientY;
        };
        var handleTouchmove = function handleTouchmove(e) {
          mouseInfo.direction = getDirection(mouseInfo.startX, mouseInfo.startY, e.changedTouches[0].clientX, e.changedTouches[0].clientY);
          if (!currentScrollArea || currentScrollArea && (mouseInfo.direction === 2 && currentScrollArea.scrollTop === 0 || mouseInfo.direction === 1 && currentScrollArea.scrollTop >= currentScrollArea.scrollHeight - currentScrollArea.offsetHeight) && e.cancelable) {
            e.preventDefault();
            e.stopPropagation();
          }
        };
        this.el.__handleTouchstart__ = handleTouchstart;
        this.el.__handleTouchmove__ = handleTouchmove;
        this.el.addEventListener('touchstart', this.el.__handleTouchstart__, false);
        this.el.addEventListener('touchmove', this.el.__handleTouchmove__, false);
      }
    }, {
      key: "render",
      value: function render() {
        var _this$props = this.props,
          forwardedRef = _this$props.forwardedRef,
          rest = _objectWithoutProperties(_this$props, _excluded);
        return /*#__PURE__*/_react.default.createElement(WrappedComponent, _extends({
          ref: forwardedRef
        }, rest, {
          withPreventScroll: this
        }));
      }
    }]);
    return PreventScroll;
  }(_react.Component);
  return /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
    return /*#__PURE__*/_react.default.createElement(PreventScroll, _extends({}, props, {
      forwardedRef: ref
    }));
  });
}

// 获得角度
function getAngle(angx, angy) {
  return Math.atan2(angy, angx) * 180 / Math.PI;
}

// 根据起点终 点返回方向 1向上 2向下 3向左 4向右 0未滑动
function getDirection(startx, starty, endx, endy) {
  var angx = endx - startx;
  var angy = endy - starty;
  var result = 0;

  // 如果滑动距离太短
  if (Math.abs(angx) < 5 && Math.abs(angy) < 5) {
    return result;
  }
  var angle = getAngle(angx, angy);
  if (angle >= -135 && angle <= -45) {
    result = 1;
  } else if (angle > 45 && angle < 135) {
    result = 2;
  } else if (angle >= 135 && angle <= 180 || angle >= -180 && angle < -135) {
    result = 3;
  } else if (angle >= -45 && angle <= 45) {
    result = 4;
  }
  return result;
}
var _default = exports.default = preventScroll;