"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _rcCheckbox = _interopRequireDefault(require("../rc-checkbox"));
var _group = _interopRequireDefault(require("./group"));
var _assist = require("../_util/assist");
var _groupContext = require("./groupContext");
var _excluded = ["children", "style", "className"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
var prefixCls = 'r-radio';
var Radio = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(Radio, _React$PureComponent);
  var _super = _createSuper(Radio);
  function Radio(props) {
    var _this;
    _classCallCheck(this, Radio);
    _this = _super.call(this, props);
    _this.onRcCheckboxChange = function (e) {
      _this.setState({
        checked: e.target.checked
      }, function () {
        _this.props.onChange && _this.props.onChange(e);
        _this.group && _this.group.onChange(e);
      });
    };
    _this.onRcCheckboxUpdated = function (RcCheckbox) {
      _this.setState({
        checked: RcCheckbox.state.checked
      });
    };
    _this.onRcCheckboxMounted = function (RcCheckbox) {
      _this.setState({
        checked: RcCheckbox.state.checked
      });
    };
    _this.state = {
      checked: false
    };
    return _this;
  }
  _createClass(Radio, [{
    key: "wrapCls",
    get: function get() {
      var _this$props = this.props,
        className = _this$props.className,
        disabled = _this$props.disabled;
      return (0, _assist.classNames)([prefixCls, className, _defineProperty(_defineProperty({}, "".concat(prefixCls, "-checked"), this.state.checked), "".concat(prefixCls, "-disabled"), disabled)]);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.group && this.group.fields.push(this);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;
      var _this$props2 = this.props,
        children = _this$props2.children,
        style = _this$props2.style,
        className = _this$props2.className,
        restProps = _objectWithoutProperties(_this$props2, _excluded);
      console.log('radio mounted or update');
      return /*#__PURE__*/_react.default.createElement(_groupContext.Consumer, null, function (context) {
        _this2.group = context;
        if (_this2.group) {
          restProps.checked = _this2.group.value === _this2.props.value;
          restProps.name = restProps.name || _this2.group.name;
          restProps.disabled = restProps.disabled || _this2.group.disabled;
        }
        return /*#__PURE__*/_react.default.createElement("label", {
          className: _this2.wrapCls,
          style: style
        }, /*#__PURE__*/_react.default.createElement(_rcCheckbox.default, _extends({
          type: "radio"
        }, restProps, {
          onChange: _this2.onRcCheckboxChange,
          onMounted: _this2.onRcCheckboxMounted,
          onUpdated: _this2.onRcCheckboxUpdated
        })), /*#__PURE__*/_react.default.createElement("span", null, children));
      });
    }
  }]);
  return Radio;
}(_react.default.PureComponent);
Radio.Group = _group.default;
var _default = exports.default = Radio;