"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _assist = require("../_util/assist");
require("./style/rc-checkbox.css");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
var prefixCls = 'rc-checkbox';
var RcCheckbox = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(RcCheckbox, _React$PureComponent);
  var _super = _createSuper(RcCheckbox);
  function RcCheckbox(props) {
    var _this;
    _classCallCheck(this, RcCheckbox);
    _this = _super.call(this, props);
    _this.handleChange = function (e) {
      var _this$props = _this.props,
        disabled = _this$props.disabled,
        onChange = _this$props.onChange;
      if (disabled) return;
      if (!('checked' in _this.props)) {
        _this.setState({
          checked: e.target.checked
        });
      }
      onChange && onChange({
        target: _objectSpread(_objectSpread({}, _this.props), {}, {
          checked: e.target.checked
        }),
        stopPropagation: function stopPropagation() {
          e.stopPropagation();
        },
        preventDefault: function preventDefault() {
          e.preventDefault();
        },
        nativeEvent: e.nativeEvent,
        component: _assertThisInitialized(_this)
      });
    };
    _this.saveInput = function (node) {
      _this.input = node;
    };
    var checked = 'checked' in props ? props.checked : props.defaultChecked;
    _this.state = {
      checked: checked
    };
    return _this;
  }
  _createClass(RcCheckbox, [{
    key: "wrapCls",
    get: function get() {
      var _this$props2 = this.props,
        className = _this$props2.className,
        disabled = _this$props2.disabled,
        type = _this$props2.type;
      var checked = this.state.checked;
      return (0, _assist.classNames)([prefixCls, className, "".concat(prefixCls, "--").concat(type), _defineProperty(_defineProperty({}, "".concat(prefixCls, "--").concat(type, "-checked"), checked), "".concat(prefixCls, "--").concat(type, "-disabled"), disabled)]);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.props.onMounted && this.props.onMounted(this);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.props.onUpdated && this.props.onUpdated(this);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
        style = _this$props3.style,
        name = _this$props3.name,
        id = _this$props3.id,
        type = _this$props3.type,
        readOnly = _this$props3.readOnly,
        disabled = _this$props3.disabled,
        value = _this$props3.value;
      var checked = this.state.checked;
      console.log('rc-checkbox mounted or updated');
      return /*#__PURE__*/_react.default.createElement("span", {
        className: this.wrapCls,
        style: style
      }, /*#__PURE__*/_react.default.createElement("input", {
        name: name,
        id: id,
        type: type,
        value: value,
        readOnly: readOnly,
        disabled: disabled,
        checked: checked,
        className: "".concat(prefixCls, "-input"),
        onChange: this.handleChange,
        ref: this.saveInput
      }), /*#__PURE__*/_react.default.createElement("span", {
        className: "".concat(prefixCls, "-inner")
      }));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(nextProps, prevState) {
      if ('checked' in nextProps) {
        return {
          checked: nextProps.checked
        };
      }
      return null;
    }
  }]);
  return RcCheckbox;
}(_react.default.PureComponent);
(0, _assist.setDefaultProps)(RcCheckbox, {
  className: {
    type: _propTypes.default.string
  },
  style: {
    type: _propTypes.default.object
  },
  type: {
    type: _propTypes.default.oneOf(['checkbox', 'radio']),
    default: 'checkbox'
  },
  defaultChecked: {
    type: _propTypes.default.bool,
    default: false
  },
  disabled: {
    type: _propTypes.default.bool,
    default: false
  },
  readOnly: {
    type: _propTypes.default.bool,
    default: false
  },
  onChange: {
    type: _propTypes.default.func
  },
  onMounted: {
    type: _propTypes.default.func
  },
  onUpdated: {
    type: _propTypes.default.func
  }
});
var _default = exports.default = RcCheckbox;